NTFS-3G(8)

NAME
ntfs-3g - Third Generation Read/Write NTFS Driver

SYNOPSIS
ntfs-3g [-o option[,...]] volume mount_point
mount -t ntfs-3g [-o option[,...]] volume mount_point

DESCRIPTION
ntfs-3g is an NTFS driver, which can create, remove, rename, move files, directories, hard links, and streams; it can read and write files, including streams and sparse files; it can handle special files like symbolic links, devices, and FIFOs; moreover it can also read transparently compressed files.

The volume to be mounted can be either a block device or an image file.

  Access Handling and Security
By default, files and directories are owned by the effective user and group of the mounting process and everybody has full read, write, execution and directory browsing permissions. If you want to use permissions handling then use the uid and/or the gid options together with the umask, or fmask and dmask options.

Windows users have full access to the files created by ntfs-3g.

Full ownership and permission support, including Windows user mapping and POSIX file system compliance, is provided by the Advanced NTFS-3G driver.

If ntfs-3g is set setuid-root then non-root users will be also able to mount volumes.

  Windows Filename Compatibility
NTFS supports several filename namespaces: DOS, Win32 and POSIX. While the ntfs-3g driver handles all of them, it always creates new files in the POSIX namespace for maximum portability and interoperability reasons. This means that filenames are case sensitive and all characters are allowed except '/' and '\0'. This is perfectly legal on Windows, though some application may get confused. If you find so then please report it to the developer of the relevant Windows software.

  Alternate Data Streams (ADS)
NTFS stores all data in streams. Every file has exactly one unnamed data stream and can have many named data streams. The size of a file is the size of its unnamed data stream. By default, ntfs-3g will only read the unnamed data stream.

By using the options "streams_interface=windows", you will be able to read any named data streams, simply by specifying the stream's name after a colon. For example:

    cat some.mp3:artist

Named data streams act like normals files, so you can read from them, write to them and even delete them (using rm). You can list all the named data streams a file has by getting the "ntfs.streams.list" extended attribute.

OPTIONS
Most of the generic mount options described in mount(8) are supported (ro, rw, suid, nosuid, dev, nodev, exec, noexec). Below is a summary of the options that ntfs-3g additionally accepts.

uid=value and gid=value
    Set the owner and the group of files and directories. The values are numerical. The defaults are the uid and gid of the current process.

umask=value
    Set the bitmask of the file and directory permissions that are not present. The value is given in octal. The default value is 0 which means full access to everybody.

fmask=value
    Set the bitmask of the file permissions that are not present. The value is given in octal. The default value is 0 which means full access to everybody.

dmask=value
    Set the bitmask of the directory permissions that are not present. The value is given in octal. The default value is 0 which means full access to everybody.

ro  Mount filesystem read-only. Useful if Windows is hibernated.

remove_hiberfile
    Unlike in case of read-only mount, the read-write mount is denied if the NTFS volume is hibernated. One needs either to resume Windows and shutdown it properly, or use this option which will remove the Windows hibernation file. Please note, this means that the saved Windows session will be completely lost. Use this option for your own responsibility.

recover, norecover
    Recover and repair a corrupted or inconsistent NTFS volume if it's possible. The default behaviour is recover.

atime, noatime, relatime
    The atime option updates inode access time for each access.

    The noatime option disables inode access time updates which can speed up file operations and prevent sleeping (notebook) disks spinning up too often thus saving energy and disk lifetime.

    The relatime option is very similar to noatime. It updates inode access times relative to modify or change time. The access time is only updated if the previous access time was earlier than the current modify or change time. Unlike noatime this option doesn't break applications that need to know if a file has been read since the last time it was modified. This is the default behaviour.

show_sys_files
    Show the system files in directory listings. Otherwise the default behaviour is to hide the system files. Please note that even when this option is specified, "$MFT" may not be visible due to a glibc bug. Furthermore, irrespectively of show_sys_files, all files are accessible by name, for example you can always do "ls -l '$UpCase'".

max_read=value
    With this option the maximum size of read operations can be set. The default is infinite. Note that the size of read requests is limited anyway to 32 pages (which is 128kbyte on i386).

silent
    Do not return error for chown and chmod unless access right handling is turned on by either of the uid, gid, umask, fmask, or dmask option. This option is on by default.

locale=value
    Prints informative and diagnostic messages in the set locale.

no_def_opts
    By default ntfs-3g acts as "silent" was passed to it, this option cancel this behaviour.

streams_interface=value
    This option controls how the user can access Alternate Data Streams (ADS) or in other words, named data streams. It can be set to, one of none, windows or xattr. If the option is set to none, the user will have no access to the named data streams. If it's set to windows, then the user can access them just like in Windows (eg. cat file:stream). If it's set to xattr, then the named data streams are mapped to xattrs and user can manipulate them using {get,set}fattr utilities. The default is xattr on Linux, none on other OSes.

force
    This mount option is not used anymore. It was superseded by the recover and norecover options.

debug
    Makes ntfs-3g to not detach from terminal and print a lot of driver debug output.

no_detach
    Same as above but with less debug output.

EXAMPLES
Mount /dev/sda1 to /mnt/windows (make sure /mnt/windows exists):

    ntfs-3g /dev/sda1 /mnt/windows

or

    mount -t ntfs-3g /dev/sda1 /mnt/windows

Read-only mount /dev/sda5 to /home/user/mnt and make user with uid 1000 to be the owner of all files:

    ntfs-3g -o ro,uid=1000 /dev/sda5 /home/user/mnt

/etc/fstab entry for the above:

    /dev/sda5 /home/user/mnt ntfs-3g ro,uid=1000 0 0

Unmount /mnt/windows:

    umount /mnt/windows

EXIT CODES
To facilitate the use of the ntfs-3g driver in scripts, an exit code is returned to give an indication of the mountability status of a volume. Value 0 means success, and all other ones mean an error. The unique error codes are documented in the ntfs-3g.probe(8) manual page.

KNOWN ISSUES
Please see

    http://ntfs-3g.org/support.html

for common questions, known issues and support.

ACKNOWLEDGEMENT
Several people made heroic efforts, often over five or more years which resulted the ntfs-3g driver. Most importantly they are Anton Altaparmakov, Richard Russon, Szabolcs Szakacsits, Yura Pakhuchiy, Yuval Fledel, Jean-Pierre Andre, Alon Bar-Lev, Dominique L Bouix, Csaba Henk, Bernhard Kaindl, Erik Larsson, Alejandro Pulver, and the author of the groundbreaking FUSE filesystem development framework, Miklos Szeredi.

SEE ALSO
ntfs-3g.probe(8), ntfsprogs(8), attr(5), getfattr(1), setfattr(1)